module jp.ku6.wallpaper.winmain;

import core.runtime;
import core.thread;
import jp.ku6.windows.win32api.windows;
import jp.ku6.windows.win32api.winuser;
import jp.ku6.wallpaper.wallpaper;

string TARGET_WINDOW_CAPTION_PREFIX = "Po";

HWND targetWindowHandle;

extern (Windows)
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	int result;

	Runtime.initialize();

	try
	{
		EnumWindows(&EnumWindowsProc, 0);
		if (targetWindowHandle !is null)
		{
			auto wallpaper = new WallPaper(targetWindowHandle);
			delete wallpaper;
		}
	}
	catch (Throwable o)
	{
		MessageBoxA(null, cast(char*)o.toString(), "Error", MB_OK | MB_ICONEXCLAMATION);
		result = 1;
	}

	Runtime.terminate();

	return result;
}

extern (Windows)
BOOL EnumWindowsProc(HWND handle, LPARAM lp)
{
	char[1024] windowCaption;
	GetWindowText(handle , windowCaption.ptr, 1024);

	for (uint i; i < TARGET_WINDOW_CAPTION_PREFIX.length; ++i)
	{
		if (windowCaption[i] == 0)
			return TRUE;

		if (windowCaption[i] != TARGET_WINDOW_CAPTION_PREFIX[i])
			return TRUE;
	}

	targetWindowHandle = handle;
	return FALSE;
}
